/* main.h
 * Copyright (C) 2007-2012 Linutop SAS <http://www.linutop.com/>
 * This file is part of the linutop config editor
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the license.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef __MAIN_H__
#define __MAIN_H__

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#define _GNU_SOURCE

#include <glib.h>
#include <gtk/gtk.h>

#include <ltop_os_info.h>

#include "utils.h"
#include "appconfig.h"

#define TEXT_EDITOR "gnome-text-editor"

enum {
    DESC = 0,
    NOM,
    COMBO_NUM
};

enum {
    LAYOUTS = 0,
    VARIANTS,
    TREE_NUM
};

enum {
    AVAIL_LAYOUT_TREE_COL_DESCRIPTION = 0,
    AVAIL_LAYOUT_TREE_COL_ID,
    NUM
};

enum tz {
    AFRICA = 0,
    AMERICA,
    US,
    CANADA,
    ASIA,
    ATLANTIC,
    AUSTRALIA,
    EUROPE,
    INDIAN,
    PACIFIC,
    SYSV,
    ETC,
    NONE,
    CONTINENTS
};

typedef struct _gui {
    GtkWidget *dialog;

    GtkWidget *locale_btn;
    GtkWidget *kbd_btn;
    GtkWidget *tz_btn;
    GtkWidget *auto_xorg_chk;
    xorgconfig *xorg_config;
    GtkWidget *autostarted_btn;
    GtkWidget *next_time;

    GtkWidget *mount_dialog;

    GtkWidget *nox_chk;
    GtkWidget *checkfs_chk;
    GtkWidget *nohwclock_chk;
    GtkWidget *reboot_chk;
    GtkWidget *reboot_min_spin;
    GtkWidget *reboot_hour_spin;

    GtkWidget *home_chk;
    GtkWidget *full_chk;
    GtkWidget *lock_chk;
    GtkWidget *lock_pwd_btn;
    GtkWidget *lock_setup_btn;

    GtkWidget *lid_combo;

    GtkWidget *nm_chk;

    gchar *lock_pwd;

    gchar *base_cmdline;

    GtkWidget *help_btn;
    GtkWidget *quit_btn;
    GtkWidget *save_btn;

    LtopOSInfo *os_info;
} gui;

/* globals */
gui *dialog;

/* prototypes */
void       layout_dialog_run  (void);
void       locale_dialog_run  (void);
void       tz_dialog_run      (void);
void       display_dialog_run (void);
void       mount_save         (void);
GtkWidget *create_mount_gui   (void);
gchar     *get_lock_passwd    (void);
void       lock_about         (void);
GtkWidget *lock_widget        (void);
GtkWidget *get_about_widget   (void);
GtkWidget *get_info_widget    (void);
GtkWidget *get_energy_widget  (void);
GtkWidget *get_service_widget (void);
GtkWidget *get_tools_widget   (void);

gboolean   warn_about_changes (void);

#endif                /* __MAIN_H__ */
