#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2011 Linutop SAS <http://www.linutop.com/>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys, glob
import xml.dom.minidom
import subprocess

cmd = ['pkg-config', 'gnome-keybindings', '--variable=keysdir']
out = subprocess.Popen (cmd, stdout=subprocess.PIPE)
keysdir = out.stdout.read().strip()
out.stdout.close ()
out.wait ()
if not keysdir:
    sys.exit (1)

print """#!/bin/sh

cat > /usr/share/gconf/mandatory/80_lock-keybindings << EOF
"""
files = glob.glob ("%s/*.xml"%keysdir)
for f in files:
    tree = xml.dom.minidom.parse (f)
    entries = tree.getElementsByTagName ("KeyListEntry")
    for e in entries:
        print e.getAttributeNode("name").value, '""'

print """EOF

exit 0
"""

